/**
*	main.h
*	CS 6610 - Advanced Computer Graphics I
*	Zach Gildersleeve
*	Nov. 6, 2006
*	
*	Main header file, contains includes, constants, and function declarations.
*/

#include "./include/stdafx.h"

#include "./include/texture.h"

void myGlutIdle(void);
void myGlutMouse(int button, int state, int x, int y);
void myGlutMotion(int x, int y);
void materialMode(int mode);
GLvoid Init(GLvoid);
void myGlutReshape(int x, int y);
GLvoid drawCone (GLvoid);
GLvoid drawSphere(GLvoid);
GLvoid drawTori(GLvoid);
void DrawRoom(void);
GLvoid buildLight(GLvoid);
float cameraDistance(void);
void shadowMatrix(GLfloat shadowMat[4][4], GLfloat groundplane[4]);
GLvoid setPlane(GLfloat a, GLfloat b, GLfloat c, GLfloat d);
GLvoid makeShadowMap(GLvoid);
GLvoid drawTriangleOccluder(GLvoid);
GLvoid drawShadowVolumeGeometry(GLvoid);
GLvoid makeShadowVolume(GLvoid);
GLvoid drawShadows(GLint mode);
void Display(void);
void glui_cb(int control);

const GLint WINDOW_WIDTH	= 512;	// the window width
const GLint WINDOW_HEIGHT	= 512;	// the window height
const GLint SHADOWMAP_SIZE	= 512;	// dimension of a cubemap face

// names for material states
const GLint ROOM_OBJECT		= 1;
const GLint CONE_OBJECT		= 2;
const GLint SPHERE_OBJECT	= 3;
const GLint LIGHT_OBJECT	= 4;
const GLint MIRROR_OBJECT	= 5;

const GLfloat GL_PI			= 3.141592654;
const GLfloat TWOPI			= 6.283185307;
const GLfloat PID2			= 1.570796327;
